<?php

namespace Ems\Logic\ProcessamentoSolicitacao;

use Ems\Util\Utils;
use Util\{ DateUtil, NovoCodigo, Repositories };

class ProcessamentoSolicitacaoEscala extends ProcessamentoSolicitacao {
    
    public function efetivar() {
        $itens = $this->getItensAssociativeArray();
        
        $nrturno        = $itens['NRTURNO']             ??  null;
        $nrmotivoescala = $itens['NRMOTIVOESCALA']      ??  null;
        $nrescalatrabm  = $itens['NRESCALATRABM']       ??  null;
        $dtiniescala    = isset($itens['DTINIESCALA'])  ?   DateUtil::getDataDeString(substr($itens['DTINIESCALA'],0,10), DateUtil::FORMATO_BRASILEIRO, true) : null;
        $dtcompetencia  = DateUtil::getDataDeString(Utils::getParamters()->getDtmescomptencDiaCorrente(), DateUtil::FORMATO_BRASILEIRO,true);
        $nrorg          = Utils::getParamters()->getNrorg();
        $nrvinculom     = $this->getSolicitacao()->getNrvinculom();
        
        $result = Utils::getEntityManager()->getRepository(Repositories::GPE_ALTEESCALA)->findBy(array("nrorg"=> $nrorg,"nrvinculom" => $nrvinculom,"dtiniescala" => $dtiniescala));

        if($result) {
            throw new \Exception("Já existe uma alteração de escala para este vinculo nesta data");
        }
        
        ProcessamentoSolicitacaoUtil::atualizaAlteEscala(
            $nrorg,
            $nrvinculom,
            $nrescalatrabm,
            DateUtil::subtraiIntervalo($dtiniescala,1,DateUtil::DIA)->format(DateUtil::FORMATO_BRASILEIRO),
            DateUtil::getDataAtual(true)->format(DateUtil::FORMATO_BRASILEIRO),
            Utils::getParamters()->getCdoperador()
        );

        ProcessamentoSolicitacaoUtil::atualizaEscalaVinculoh(
            $nrorg,
            $nrvinculom,
            $nrescalatrabm,
            DateUtil::getDataAtual(true)->format(DateUtil::FORMATO_BRASILEIRO),
            Utils::getParamters()->getCdoperador()
        );
        
        $alteEscala = ProcessamentoSolicitacaoUtil::novoAlteEscala($nrorg, $nrvinculom, $nrturno, $nrmotivoescala, $nrescalatrabm, $dtiniescala);
    }
    
    public function rejeitar() {}
    
}