<?php
/**
 * Created by PhpStorm.
 * User: felipesantos
 * Date: 02/09/2015
 * Time: 14:07
 */

namespace Service\Hcm;

use Util\NovoCodigo;

class PessoaService {

    private $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function getPessoaByNrpessoaAndCompetenciaAndNrorg($nrpessoa, $dtmescompetenc, $nrorg){
        try {
            $query = <<<SQL
SELECT PH.NMPESSOA,
       PH.NRCPFPESSOA,
       CC.CDBANCO,
       CC.CDAGENCIA,
       CC.CDCONTCORR
  FROM GPE_PESSOA PE
  JOIN GPE_PESSOAH PH ON PH.NRORG = PE.NRORG
                  AND PH.NRPESSOA = PE.NRPESSOA
  JOIN (SELECT MAX(GPE_PESSOAH.DTMESCOMPETENC) DTMESCOMPETENC,
               GPE_PESSOAH.NRPESSOA,
               GPE_PESSOAH.NRORG
          FROM GPE_PESSOAH
         GROUP BY GPE_PESSOAH.NRPESSOA, GPE_PESSOAH.NRORG)MAX_PESSOAH ON PH.DTMESCOMPETENC = MAX_PESSOAH.DTMESCOMPETENC
                                                                     AND PH.NRORG = MAX_PESSOAH.NRORG
                                                                     AND PH.NRPESSOA = MAX_PESSOAH.NRPESSOA
  JOIN PARCNEGOCIO PN ON PN.NRORG = PE.NRORG
                     AND PN.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
  LEFT JOIN CONTCORRPARC CC ON CC.NRORG = PN.NRORG
                           AND CC.NRPARCNEGOCIO = PN.NRPARCNEGOCIO
                           AND CC.IDATIVO = 'S'
 WHERE PH.NRORG = :P_NRORG
   AND PH.NRPESSOA = :P_NRPESSOA
SQL;
            $params = array(
                'P_NRORG' => $nrorg,
                'P_NRPESSOA' => $nrpessoa,
                'P_DTMESCOMPETENC' => $dtmescompetenc
            );
            $array = $this->entityManager->getConnection()->fetchAll($query, $params);
            return empty($array) ? $array : $array[0];
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getPessoaByCpfAndCompetenciaAndNrorg($nrcpfpessoa, $dtmescompetenc, $nrorg){
        try {
            $query = <<<SQL
SELECT PE.NRPARCNEGOCIO, PH.*
  FROM GPE_PESSOA PE
  JOIN GPE_PESSOAH PH ON PH.NRORG = PE.NRORG
                     AND PH.NRPESSOA = PE.NRPESSOA
                     AND PH.DTMESCOMPETENC = (SELECT MAX(GPE_PESSOAH.DTMESCOMPETENC)
                                                FROM GPE_PESSOAH
                                               WHERE GPE_PESSOAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')
                                                 AND GPE_PESSOAH.NRORG = PH.NRORG
                                                 AND GPE_PESSOAH.NRPESSOA = PH.NRPESSOA)
 WHERE PH.NRORG = :P_NRORG
   AND PH.NRCPFPESSOA = :P_NRCPFPESSOA
SQL;
            $params = array(
                'P_NRORG' => $nrorg,
                'P_NRCPFPESSOA' => $nrcpfpessoa,
                'P_DTMESCOMPETENC' => $dtmescompetenc
            );
            $array = $this->entityManager->getConnection()->fetchAssoc($query, $params);
            return $array;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getContaPessoaByNrpessoaAndNrorg($nrpessoa, $nrorg, $cdbanco = null){
        try {
            $query = <<<SQL
SELECT CC.*, BC.*, TC.*
  FROM GPE_PESSOA PE
  JOIN PARCNEGOCIO PN ON PN.NRORG = PE.NRORG
                     AND PN.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
  JOIN CONTCORRPARC CC ON CC.NRORG = PN.NRORG
                      AND CC.NRPARCNEGOCIO = PN.NRPARCNEGOCIO
                      AND CC.IDATIVO = 'S'
  JOIN BANCO BC ON BC.CDBANCO = CC.CDBANCO
  JOIN TPCONTCORR TC ON TC.NRTPCONTCORR = CC.NRTPCONTCORR
 WHERE PE.NRORG = :P_NRORG
   AND PE.NRPESSOA = :P_NRPESSOA
   AND ((CC.CDBANCO = :P_CDBANCO) OR (:P_CDBANCO IS NULL))
SQL;
            $params = array(
                'P_NRORG' => $nrorg,
                'P_NRPESSOA' => $nrpessoa,
                'P_CDBANCO' => $cdbanco
            );
            $contas = $this->entityManager->getConnection()->fetchAll($query, $params);
            return $contas;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getContaCorrenteByNrparceiroAndNrorg($nrparcnegocio, $nrorg, $cdbanco = null){
        try {
            $query = <<<SQL
SELECT CC.*, BC.*, TC.*
  FROM PARCNEGOCIO PN
  JOIN CONTCORRPARC CC ON CC.NRORG = PN.NRORG
                      AND CC.NRPARCNEGOCIO = PN.NRPARCNEGOCIO
                      AND CC.IDATIVO = 'S'
  JOIN BANCO BC ON BC.CDBANCO = CC.CDBANCO
  JOIN TPCONTCORR TC ON TC.NRTPCONTCORR = CC.NRTPCONTCORR
 WHERE PN.NRORG = :P_NRORG
   AND PN.NRPARCNEGOCIO = :P_NRPARCNEGOCIO
   AND ((CC.CDBANCO = :P_CDBANCO) OR (:P_CDBANCO IS NULL))
SQL;
            $params = array(
                'P_NRORG' => $nrorg,
                'P_NRPARCNEGOCIO' => $nrparcnegocio,
                'P_CDBANCO' => $cdbanco
            );
            $contas = $this->entityManager->getConnection()->fetchAll($query, $params);
            return $contas;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getVinculosByEstruturaAndCompetenciaAndNrorg($nrestruturam, $dtmescompetenc, $nrorg, $nrtipovinculom=null, $idvincrescindidos=null){
        try {
            $tipovinculo = "";
            if (!is_null($nrtipovinculom)) {
                $tipovinculo = " AND VM.NRTIPOVINCULOM IN ($nrtipovinculom) ";
            }
            
            $query = <<<SQL
SELECT VM.*,
       NVL(EMG.CDINTESTRUTEXPFIL,EML.CDINTESTRUTEXPFIL) AS CDEXPFILIAL,
       EMG.CDINTESTRUTEXP AS CDEXPCENTCUST,
       EMG.CDEXPPDRATEIO AS CDEXPPDRATEIO
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND TRUNC(H1.DTMESCOMPETENC,'DD') <= TO_DATE(:P_DTMESCOMPETENC,'DD/MM/YYYY'))
  JOIN ESTRUTURAM EML ON EML.NRORG = VH.NRORG
                     AND EML.NRESTRUTURAM = VH.NRESTRUTLEGAL
  JOIN ESTRUTURAM EMG ON EMG.NRORG = VH.NRORG
                     AND EMG.NRESTRUTURAM = VH.NRESTRUTGEREN
 WHERE VH.NRESTRUTLEGAL = :P_NRESTRUTURAM
   AND VH.NRORG = :P_NRORG
   AND (((VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC > LAST_DAY(TO_DATE(:P_DTMESCOMPETENC,'DD/MM/YYYY'))) AND NVL(:P_IDVINCRESCINDIDOS,'N') = 'N') OR :P_IDVINCRESCINDIDOS = 'S')
   $tipovinculo
SQL;
            $params = array(
                'P_DTMESCOMPETENC' => $dtmescompetenc,
                'P_NRESTRUTURAM' => $nrestruturam,
                'P_NRORG' => $nrorg,
                'P_NRTIPOVINCULOM' => $nrtipovinculom,
                'P_IDVINCRESCINDIDOS' => $idvincrescindidos,
            );

            $vinculos = $this->entityManager->getConnection()->fetchAll($query, $params);
            return $vinculos;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getVinculosByEstruturasAndCompetenciaAndNrorg($nrestrutlegal, $nrestrutgeren, $nrestrutsind, $dtmescompetenc, $nrorg, $nrtipovinculom=null, $idvincrescindidos=null){
        try {
            $tipovinculo = "";
            if (!is_null($nrtipovinculom)) {
                $tipovinculo = " AND VM.NRTIPOVINCULOM IN ($nrtipovinculom) ";
            }
            
            $query = <<<SQL
SELECT VM.*,
       NVL(EMG.CDINTESTRUTEXPFIL,EML.CDINTESTRUTEXPFIL) AS CDEXPFILIAL,
       EMG.CDINTESTRUTEXP AS CDEXPCENTCUST,
       EMG.CDEXPPDRATEIO AS CDEXPPDRATEIO
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND TRUNC(H1.DTMESCOMPETENC,'DD') <= TO_DATE(:P_DTMESCOMPETENC,'DD/MM/YYYY'))
  JOIN ESTRUTURAM EML ON EML.NRORG = VH.NRORG
                     AND EML.NRESTRUTURAM = VH.NRESTRUTLEGAL
  JOIN ESTRUTURAM EMG ON EMG.NRORG = VH.NRORG
                     AND EMG.NRESTRUTURAM = VH.NRESTRUTGEREN
 WHERE (INSTR(','||REPLACE(:P_NRESTRUTLEGAL,' ','')||',', ','||VH.NRESTRUTLEGAL||',') > 0 OR :P_NRESTRUTLEGAL IS NULL)  
   AND (INSTR(','||REPLACE(:P_NRESTRUTGEREN,' ','')||',', ','||VH.NRESTRUTGEREN||',') > 0 OR :P_NRESTRUTGEREN IS NULL)
   AND (INSTR(','||REPLACE(:P_NRESTRUTSIND,' ','')||',', ','||VH.NRESTRUTSIND||',') > 0 OR :P_NRESTRUTSIND IS NULL)
   AND VH.NRORG = :P_NRORG
   AND (((VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC > LAST_DAY(TO_DATE(:P_DTMESCOMPETENC,'DD/MM/YYYY'))) AND NVL(:P_IDVINCRESCINDIDOS,'N') = 'N') OR :P_IDVINCRESCINDIDOS = 'S')
   $tipovinculo
SQL;
            $params = array(
                'P_DTMESCOMPETENC' => $dtmescompetenc,
                'P_NRESTRUTLEGAL' => $nrestrutlegal,
                'P_NRESTRUTGEREN' => $nrestrutgeren,
                'P_NRESTRUTSIND' => $nrestrutsind,
                'P_NRORG' => $nrorg,
                'P_NRTIPOVINCULOM' => $nrtipovinculom,
                'P_IDVINCRESCINDIDOS' => $idvincrescindidos,
            );

            $vinculos = $this->entityManager->getConnection()->fetchAll($query, $params);
            return $vinculos;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getVinculoByCpfAndFilial($nrorg, $dtmescompetenc, $nrcpfpessoa, $cdfilial){
        try {
            $query = <<<SQL
SELECT VM.DTADMISSAOVINC, VM.DTRESCISAOVINC, VH.*
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND TRUNC(H1.DTMESCOMPETENC,'DD') <= TO_DATE(:P_DTMESCOMPETENC,'DD/MM/YYYY'))
  JOIN GPE_PESSOAH PH ON PH.NRORG = VM.NRORG
                     AND PH.NRPESSOA = VM.NRPESSOA
                     AND PH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH H1
                                               WHERE H1.NRPESSOA = PH.NRPESSOA
                                                 AND H1.NRORG = PH.NRORG
                                                 AND TRUNC(H1.DTMESCOMPETENC,'DD') <= TO_DATE(:P_DTMESCOMPETENC,'DD/MM/YYYY'))
  JOIN ESTRUTURAM EML ON EML.NRORG = VH.NRORG
                     AND EML.NRESTRUTURAM = VH.NRESTRUTLEGAL
  JOIN ESTRUTURAM EMG ON EMG.NRORG = VH.NRORG
                     AND EMG.NRESTRUTURAM = VH.NRESTRUTGEREN
 WHERE VH.NRORG = :P_NRORG
   AND (EML.CDINTESTRUTEXPFIL = :P_CDFILIAL OR EMG.CDINTESTRUTEXPFIL = :P_CDFILIAL)
   AND PH.NRCPFPESSOA = :P_NRCPFPESSOA
SQL;
            $params = array(
                'P_NRORG' => $nrorg,
                'P_DTMESCOMPETENC' => $dtmescompetenc,
                'P_CDFILIAL' => $cdfilial,
                'P_NRCPFPESSOA' => $nrcpfpessoa,
            );

            $vinculos = $this->entityManager->getConnection()->fetchAll($query, $params);
            return $vinculos;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getVinculoByCpfAndFilialandCentroCusto($nrorg, $dtmescompetenc, $nrcpfpessoa, $cdfilial, $cdcentrocusto){
        try {
            $query = <<<SQL
SELECT VM.*
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND TRUNC(H1.DTMESCOMPETENC,'DD') <= TO_DATE(:P_DTMESCOMPETENC,'DD/MM/YYYY'))
  JOIN GPE_PESSOAH PH ON PH.NRORG = VM.NRORG
                     AND PH.NRPESSOA = VM.NRPESSOA
                     AND PH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH H1
                                               WHERE H1.NRPESSOA = PH.NRPESSOA
                                                 AND H1.NRORG = PH.NRORG
                                                 AND TRUNC(H1.DTMESCOMPETENC,'DD') <= TO_DATE(:P_DTMESCOMPETENC,'DD/MM/YYYY'))
  JOIN ESTRUTURAM EML ON EML.NRORG = VH.NRORG
                     AND EML.NRESTRUTURAM = VH.NRESTRUTLEGAL
  JOIN ESTRUTURAM EMG ON EMG.NRORG = VH.NRORG
                     AND EMG.NRESTRUTURAM = VH.NRESTRUTGEREN
 WHERE VH.NRORG = :P_NRORG
   AND (EML.CDINTESTRUTEXPFIL = :P_CDFILIAL OR EMG.CDINTESTRUTEXPFIL = :P_CDFILIAL)
   AND EMG.CDINTESTRUTEXP = :P_CDCENTCUSTO
   AND PH.NRCPFPESSOA = :P_NRCPFPESSOA
SQL;
            $params = array(
                'P_NRORG' => $nrorg,
                'P_DTMESCOMPETENC' => $dtmescompetenc,
                'P_CDFILIAL' => $cdfilial,
                'P_CDCENTCUSTO' => $cdcentrocusto,
                'P_NRCPFPESSOA' => $nrcpfpessoa,
            );

            $vinculos = $this->entityManager->getConnection()->fetchAll($query, $params);
            return $vinculos;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getMovimentacaoGerencial($nrorg, $dtmescompetenc, $nrvinculom){
        try {
            $query = <<<SQL
SELECT MO.*
  FROM GPE_MOVIMENTACAO MO
  JOIN GPE_PARAMORG PO ON PO.NRORG = MO.NRORG
                      AND PO.NRTPESTRUTGEREN = MO.NRTIPOESTRUTURA
 WHERE MO.NRORG = :P_NRORG
   AND MO.NRVINCULOM = :P_NRVINCULOM
   AND MO.DTINIMOVIMENT <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')
   AND (MO.DTFIMMOVIMENT >= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY') OR MO.DTFIMMOVIMENT IS NULL)
SQL;
            $params = array(
                'P_NRORG' => $nrorg,
                'P_DTMESCOMPETENC' => $dtmescompetenc,
                'P_NRVINCULOM' => $nrvinculom,
            );

            $movimentacao = $this->entityManager->getConnection()->fetchAll($query, $params);
            return $movimentacao;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function addMovimentacao($nrorg, $nrmovimentacao, $nrvinculom, $nrtipotransfer, $nrtpmovtransfm, $nrtipoestrutura, $nrestruturam, $dtinimoviment, $dtfimmoviment, 
                                    $idatualizaacerto, $dsobservacao, $cdoperador){
        try {
            $sql = <<<SQL
INSERT INTO GPE_MOVIMENTACAO
    (NRORG, NRMOVIMENTACAO, NRVINCULOM, NRTIPOTRANSFER, NRTPMOVTRANSFM, NRTIPOESTRUTURA, NRESTRUTURAM, DTINIMOVIMENT, DTFIMMOVIMENT, IDATUALIZAACERTO, DSOBSERVACAO, NRORGINCLUSAO, CDOPERINCLUSAO, DTINCLUSAO)
VALUES 
    (:NRORG, :NRMOVIMENTACAO, :NRVINCULOM, :NRTIPOTRANSFER, :NRTPMOVTRANSFM, :NRTIPOESTRUTURA, :NRESTRUTURAM, TO_DATE(:DTINIMOVIMENT,'DD/MM/YYYY'), TO_DATE(:DTFIMMOVIMENT,'DD/MM/YYYY'), :IDATUALIZAACERTO, :DSOBSERVACAO, :NRORGINCLUSAO, :CDOPERINCLUSAO, SYSDATE)
SQL;
            $params = array(
                'NRORG' => $nrorg,
                'NRMOVIMENTACAO' => $nrmovimentacao,
                'NRVINCULOM' => $nrvinculom,
                'NRTIPOTRANSFER' => $nrtipotransfer,
                'NRTPMOVTRANSFM' => $nrtpmovtransfm,
                'NRTIPOESTRUTURA' => $nrtipoestrutura,
                'NRESTRUTURAM' => $nrestruturam,
                'DTINIMOVIMENT' => $dtinimoviment,
                'DTFIMMOVIMENT' => $dtfimmoviment,
                'IDATUALIZAACERTO' => $idatualizaacerto,
                'DSOBSERVACAO' => $dsobservacao,
                'NRORGINCLUSAO' => $nrorg,
                'CDOPERINCLUSAO' => $cdoperador,
            );
            $result = $this->entityManager->getConnection()->prepare($sql)->execute($params);
            return $result;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function updateDataFimMovimentacao($nrorg, $nrmovimentacao, $dtfimmoviment, $cdoperador){
        try {
            $sql = <<<SQL
UPDATE GPE_MOVIMENTACAO
   SET DTFIMMOVIMENT = TO_DATE(:DTFIMMOVIMENT, 'DD/MM/YYYY'),
       CDOPERULTATU = :CDOPERULTATU,
       DTULTATU = SYSDATE
 WHERE NRORG = :NRORG
   AND NRMOVIMENTACAO = :NRMOVIMENTACAO
SQL;
            $params = array(
                'NRORG' => $nrorg,
                'NRMOVIMENTACAO' => $nrmovimentacao,
                'DTFIMMOVIMENT' => $dtfimmoviment,
                'CDOPERULTATU' => $cdoperador,
            );
            $result = $this->entityManager->getConnection()->prepare($sql)->execute($params);
            return $result;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function atualizaHistoricoVinculo($nrorg, $nrvinculom, $dtmescompetenc, $cdoperador, $criaNovo=true, $posteriores=true, $nrestrutlegal=null, $nrestrutgeren=null) {
        try {
            if ($criaNovo) {
                // Verifica se existe histórico para a competência
                $query = <<<SQL
SELECT VH.*
  FROM GPE_VINCULOH VH
 WHERE VH.NRORG = :P_NRORG
   AND VH.NRVINCULOM = :P_NRVINCULOM
   AND VH.DTMESCOMPETENC = TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')
SQL;
                $params = array(
                    'P_NRORG' => $nrorg,
                    'P_NRVINCULOM' => $nrvinculom,
                    'P_DTMESCOMPETENC' => $dtmescompetenc,
                );
                $historico = $this->entityManager->getConnection()->fetchAssoc($query, $params);
                
                if ($historico === false) {
                    // Caso não exista busca o último histórico anterior à competencia
                    $query = <<<SQL
SELECT VH.*
  FROM GPE_VINCULOH VH
 WHERE VH.NRORG = :P_NRORG
   AND VH.NRVINCULOM = :P_NRVINCULOM
   AND VH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')
 ORDER BY VH.DTMESCOMPETENC DESC
SQL;
                    $params = array(
                        'P_NRORG' => $nrorg,
                        'P_NRVINCULOM' => $nrvinculom,
                        'P_DTMESCOMPETENC' => $dtmescompetenc,
                    );
                    $historico = $this->entityManager->getConnection()->fetchAssoc($query, $params);

                    // Cria um novo histórico com base no histórico anterior
                    $nrvinculoh = NovoCodigo::geraCodigo($nrorg, "GPE_VINCULOH", 1, 20, true, false);
                    $sql = <<<SQL
INSERT INTO GPE_VINCULOH
    (NRORG, NRVINCULOH, NRVINCULOM, DTMESCOMPETENC, NRSITUFUNCM, NRCARGO, NRESCALATRABM, IDCONTRIBUISIND, NRDEPENDIR, NRDEPENDSFAM, DTBASEFERIAS, IDREMUNERACAO, IDTPPAGAMENTO, NRESTRUTLEGAL, NRESTRUTGEREN, NRTPMODALIDSAL, IDMULTVINC, NRFUNCAO, CDCONTRIBINDIVIDUAL, NRTPMOVTRANSFM, DTFIMCONTRDETERMIN, NRESTRUTSIND, CONFIDENCIAL, NRDIASAPURVALES, NRTURNO, NRTPREGIMEPREV, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
VALUES
    (:NRORG, :NRVINCULOH, :NRVINCULOM, TO_DATE(:DTMESCOMPETENC, 'DD/MM/YYYY'), :NRSITUFUNCM, :NRCARGO, :NRESCALATRABM, :IDCONTRIBUISIND, :NRDEPENDIR, :NRDEPENDSFAM, :DTBASEFERIAS, :IDREMUNERACAO, :IDTPPAGAMENTO, :NRESTRUTLEGAL, :NRESTRUTGEREN, :NRTPMODALIDSAL, :IDMULTVINC, :NRFUNCAO, :CDCONTRIBINDIVIDUAL, :NRTPMOVTRANSFM, :DTFIMCONTRDETERMIN, :NRESTRUTSIND, :CONFIDENCIAL, :NRDIASAPURVALES, :NRTURNO, :NRTPREGIMEPREV, SYSDATE, :NRORGINCLUSAO, :CDOPERINCLUSAO)
SQL;
                    $params = array(
                        'NRORG' => $nrorg,
                        'NRVINCULOH' => $nrvinculoh,
                        'NRVINCULOM' => $nrvinculom,
                        'DTMESCOMPETENC' => $dtmescompetenc,
                        'NRSITUFUNCM' => $historico['NRSITUFUNCM'],
                        'NRCARGO' => $historico['NRCARGO'],
                        'NRESCALATRABM' => $historico['NRESCALATRABM'],
                        'IDCONTRIBUISIND' => $historico['IDCONTRIBUISIND'],
                        'NRDEPENDIR' => $historico['NRDEPENDIR'],
                        'NRDEPENDSFAM' => $historico['NRDEPENDSFAM'],
                        'DTBASEFERIAS' => $historico['DTBASEFERIAS'],
                        'IDREMUNERACAO' => $historico['IDREMUNERACAO'],
                        'IDTPPAGAMENTO' => $historico['IDTPPAGAMENTO'],
                        'NRESTRUTLEGAL' => $historico['NRESTRUTLEGAL'],
                        'NRESTRUTGEREN' => $historico['NRESTRUTGEREN'],
                        'NRTPMODALIDSAL' => $historico['NRTPMODALIDSAL'],
                        'IDMULTVINC' => $historico['IDMULTVINC'],
                        'NRFUNCAO' => $historico['NRFUNCAO'],
                        'CDCONTRIBINDIVIDUAL' => $historico['CDCONTRIBINDIVIDUAL'],
                        'NRTPMOVTRANSFM' => $historico['NRTPMOVTRANSFM'],
                        'DTFIMCONTRDETERMIN' => $historico['DTFIMCONTRDETERMIN'],
                        'NRESTRUTSIND' => $historico['NRESTRUTSIND'],
                        'CONFIDENCIAL' => $historico['CONFIDENCIAL'],
                        'NRDIASAPURVALES' => $historico['NRDIASAPURVALES'],
                        'NRTURNO' => $historico['NRTURNO'],
                        'NRTPREGIMEPREV' => $historico['NRTPREGIMEPREV'],
                        'NRORGINCLUSAO' => $nrorg,
                        'CDOPERINCLUSAO' => $cdoperador,
                    );
                    $result = $this->entityManager->getConnection()->prepare($sql)->execute($params);
                }
            }

            // Atualiza o histórico da competência passada, e os posteriores se solicitado
            $sql = <<<SQL
UPDATE GPE_VINCULOH
   SET NRESTRUTLEGAL = NVL(:NRESTRUTLEGAL, NRESTRUTLEGAL),
       NRESTRUTGEREN = NVL(:NRESTRUTGEREN, NRESTRUTGEREN),
       CDOPERULTATU = :CDOPERULTATU,
       DTULTATU = SYSDATE
 WHERE NRORG = :NRORG
   AND NRVINCULOM = :NRVINCULOM
   AND (DTMESCOMPETENC = TO_DATE(:DTMESCOMPETENC, 'DD/MM/YYYY') OR (DTMESCOMPETENC > TO_DATE(:DTMESCOMPETENC, 'DD/MM/YYYY') AND :POSTERIORES = 'S'))
SQL;
            $params = array(
                'NRORG' => $nrorg,
                'NRVINCULOM' => $nrvinculom,
                'DTMESCOMPETENC' => $dtmescompetenc,
                'NRESTRUTLEGAL' => $nrestrutlegal,
                'NRESTRUTGEREN' => $nrestrutgeren,
                'CDOPERULTATU' => $cdoperador,
                'POSTERIORES' => ($posteriores === true ? 'S' : 'N')
            );

            $result = $this->entityManager->getConnection()->prepare($sql)->execute($params);
            return $result;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getDadosPessoa($nrorg, $dtmescompetenc, $cdcnpjestrut, $cdfilial, $cdcentcust, $nrcpfpessoa, $dtreferencia, $cdintegocupa){
        try {
            $dados = array();

            if (!is_null($nrcpfpessoa)) {
                $nrcpfpessoa = explode(',', $nrcpfpessoa);
                $nrcpfpessoa = '_' . implode('_', $nrcpfpessoa) . '_';
            }

            /* Busca os dados da tabela gpe_pessoah */
            $query = <<<SQL
SELECT VM.NRVINCULOM, VH.NRVINCULOH, PH.*
  FROM GPE_PESSOA PE
  JOIN GPE_PESSOAH PH ON PH.NRORG = PE.NRORG
                     AND PH.NRPESSOA = PE.NRPESSOA
                     AND PH.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM GPE_PESSOAH H1
                                               WHERE H1.NRORG = PH.NRORG
                                                 AND H1.NRPESSOA = PH.NRPESSOA
                                                 AND H1.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
  JOIN GPE_VINCULOM VM ON VM.NRORG = PH.NRORG
                      AND VM.NRPESSOA = PH.NRPESSOA
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRORG = VH.NRORG
                                                  AND H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
  LEFT JOIN GPE_OCUPACAOH OH ON OH.NRORG = VH.NRORG
                            AND (OH.NROCUPACAOM = VH.NRCARGO OR OH.NROCUPACAOM = VH.NRFUNCAO)
                            AND OH.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM GPE_OCUPACAOH H1
                                                      WHERE H1.NRORG = OH.NRORG
                                                        AND H1.NROCUPACAOM = OH.NROCUPACAOM
                                                        AND H1.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
  JOIN ESTRUTURAM EML ON EML.NRORG = VH.NRORG
                     AND EML.NRESTRUTURAM = VH.NRESTRUTLEGAL
  JOIN ESTRUTURAH EHL ON EHL.NRORG = EML.NRORG
                     AND EHL.NRESTRUTURAM = EML.NRESTRUTURAM
                     AND EHL.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                WHERE H1.NRORG = EHL.NRORG
                                                  AND H1.NRESTRUTURAM = EHL.NRESTRUTURAM
                                                  AND H1.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
  JOIN ESTRUTURAM EMG ON EMG.NRORG = VH.NRORG
                     AND EMG.NRESTRUTURAM = VH.NRESTRUTGEREN
 WHERE PE.NRORG = :P_NRORG
   AND PH.NRCPFPESSOA IS NOT NULL
   AND (VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC >= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
   AND (EHL.CDCNPJESTRUT = :P_CDCNPJESTRUT OR :P_CDCNPJESTRUT IS NULL)
   AND (EML.CDINTESTRUTEXPFIL = :P_CDFILIAL OR :P_CDFILIAL IS NULL)
   AND (EMG.CDINTESTRUTEXP = :P_CDCENTCUST OR :P_CDCENTCUST IS NULL)
   AND (INSTR(:P_NRCPFPESSOA, '_'||PH.NRCPFPESSOA||'_') > 0 OR :P_NRCPFPESSOA IS NULL)
   AND (PE.DTINCLUSAO >= TO_DATE(:P_DTREFERENCIA, 'DD/MM/YYYY') OR :P_DTREFERENCIA IS NULL)
   AND (OH.CDINTEGRACAO = :P_CDINTEGOCUPA OR :P_CDINTEGOCUPA IS NULL)
SQL;
            $params = array(
                'P_NRORG' => $nrorg,
                'P_DTMESCOMPETENC' => $dtmescompetenc,
                'P_CDCNPJESTRUT' => $cdcnpjestrut,
                'P_CDFILIAL' => $cdfilial,
                'P_CDCENTCUST' => $cdcentcust,
                'P_NRCPFPESSOA' => $nrcpfpessoa,
                'P_DTREFERENCIA' => $dtreferencia,
                'P_CDINTEGOCUPA' => $cdintegocupa,
            );
            $results = $this->entityManager->getConnection()->fetchAll($query, $params);

            foreach ($results as $key => $gpe_pessoah) {

                /* Busca os dados da tabela gpe_pessoa */
                $query = <<<SQL
SELECT *
  FROM GPE_PESSOA
 WHERE NRORG = :P_NRORG
   AND NRPESSOA = :P_NRPESSOA
SQL;
                $params = array(
                    'P_NRORG' => $nrorg,
                    'P_NRPESSOA' => $gpe_pessoah['NRPESSOA'],
                );
                $gpe_pessoa = $this->entityManager->getConnection()->fetchAssoc($query, $params);


                /* Busca os dados da tabela parcnegocio */
                $query = <<<SQL
SELECT *
  FROM PARCNEGOCIO
 WHERE NRORG = :P_NRORG
   AND NRPARCNEGOCIO = :P_NRPARCNEGOCIO
SQL;
                $params = array(
                    'P_NRORG' => $nrorg,
                    'P_NRPARCNEGOCIO' => $gpe_pessoa['NRPARCNEGOCIO'],
                );
                $parcnegocio = $this->entityManager->getConnection()->fetchAssoc($query, $params);


                /* Busca os dados da tabela enderecoparc */
                $query = <<<SQL
SELECT MUNI.NMMUNICIPIO, EST.NMESTADO, PA.NMPAIS, ENDE.*
  FROM ENDERECOPARC ENDE
  LEFT JOIN MUNICIPIO MUNI ON MUNI.CDMUNICIPIO = ENDE.CDMUNICIPIO
                     AND MUNI.SGESTADO = ENDE.SGESTADO
  LEFT JOIN ESTADO EST ON EST.SGESTADO = ENDE.SGESTADO
                     AND EST.CDPAIS = ENDE.CDPAIS
  LEFT JOIN PAIS PA ON PA.CDPAIS = ENDE.CDPAIS
 WHERE ENDE.NRORG = :P_NRORG
   AND ENDE.NRPARCNEGOCIO = :P_NRPARCNEGOCIO
SQL;
                $params = array(
                    'P_NRORG' => $nrorg,
                    'P_NRPARCNEGOCIO' => $gpe_pessoa['NRPARCNEGOCIO'],
                );
                $enderecoparc = $this->entityManager->getConnection()->fetchAll($query, $params);


                /* Busca os dados da tabela comunicaparc */
                $query = <<<SQL
SELECT *
  FROM COMUNICAPARC
 WHERE NRORG = :P_NRORG
   AND NRPARCNEGOCIO = :P_NRPARCNEGOCIO
SQL;
                $params = array(
                    'P_NRORG' => $nrorg,
                    'P_NRPARCNEGOCIO' => $gpe_pessoa['NRPARCNEGOCIO'],
                );
                $comunicaparc = $this->entityManager->getConnection()->fetchAll($query, $params);


                /* Busca os dados da tabela contcorrparc */
                $query = <<<SQL
SELECT *
  FROM CONTCORRPARC
 WHERE NRORG = :P_NRORG
   AND NRPARCNEGOCIO = :P_NRPARCNEGOCIO
   AND IDATIVO = 'S'
SQL;
                $params = array(
                    'P_NRORG' => $nrorg,
                    'P_NRPARCNEGOCIO' => $gpe_pessoa['NRPARCNEGOCIO'],
                );
                $contcorrparc = $this->entityManager->getConnection()->fetchAll($query, $params);


                /* Busca os dados da tabela gpe_vinculom */
                $query = <<<SQL
SELECT *
  FROM GPE_VINCULOM
 WHERE NRORG = :P_NRORG
   AND NRVINCULOM = :P_NRVINCULOM
SQL;
                $params = array(
                    'P_NRORG' => $nrorg,
                    'P_NRVINCULOM' => $gpe_pessoah['NRVINCULOM'],
                );
                $gpe_vinculom = $this->entityManager->getConnection()->fetchAssoc($query, $params);


                /* Busca os dados da tabela gpe_vinculoh */
                $query = <<<SQL
SELECT ESTRUTLEGAL.NMESTRUTURAM AS NMESTRUTLEGAL, ESTRUTGEREN.NMESTRUTURAM AS NMESTRUTGEREN, ESTRUTSIND.NMESTRUTURAM AS NMESTRUTSIND, VH.*
  FROM GPE_VINCULOH VH
  LEFT JOIN ESTRUTURAM ESTRUTLEGAL ON ESTRUTLEGAL.NRESTRUTURAM = VH.NRESTRUTLEGAL 
                         AND ESTRUTLEGAL.NRORG = VH.NRORG 
  LEFT JOIN ESTRUTURAM ESTRUTGEREN ON ESTRUTGEREN.NRESTRUTURAM = VH.NRESTRUTGEREN 
                         AND ESTRUTGEREN.NRORG = VH.NRORG 
  LEFT JOIN ESTRUTURAM ESTRUTSIND ON ESTRUTSIND.NRESTRUTURAM = VH.NRESTRUTSIND 
                         AND ESTRUTSIND.NRORG = VH.NRORG
 WHERE VH.NRORG = :P_NRORG
   AND VH.NRVINCULOH = :P_NRVINCULOH
SQL;
                $params = array(
                    'P_NRORG' => $nrorg,
                    'P_NRVINCULOH' => $gpe_pessoah['NRVINCULOH'],
                );
                $gpe_vinculoh = $this->entityManager->getConnection()->fetchAssoc($query, $params);


                /* Busca os dados das tabelas gpe_ocupacaom e gpe_ocupacaoh */
                $query = <<<SQL
SELECT OM.NRTIPOOCUPACAO, OM.DTINIVIGENCIA, OM.DTFIMVIGENCIA, OH.*
  FROM GPE_OCUPACAOM OM
  JOIN GPE_OCUPACAOH OH ON OH.NRORG = OM.NRORG
                       AND OH.NROCUPACAOM = OM.NROCUPACAOM
                       AND OH.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM GPE_OCUPACAOH H1
                                                 WHERE H1.NRORG = OH.NRORG
                                                   AND H1.NROCUPACAOM = OH.NROCUPACAOM
                                                   AND H1.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
 WHERE OM.NRORG = :P_NRORG
   AND OM.NROCUPACAOM = :P_NROCUPACAOM
SQL;
                $params = array(
                    'P_NRORG' => $nrorg,
                    'P_NROCUPACAOM' => $gpe_vinculoh['NRCARGO'],
                    'P_DTMESCOMPETENC' => $dtmescompetenc,
                );
                $gpe_ocupacao = $this->entityManager->getConnection()->fetchAssoc($query, $params);


                /* Busca os dados das tabelas gpe_alteescala, gpe_escalatrabm e gpe_escalatrabh */
                $query = <<<SQL
SELECT AE.NRALTEESCALA, AE.DTINIESCALA, AE.DTFIMESCALA, AE.NRHORDIAM, AE.NRMOTIVOESCALA, AE.NRTURNO, AE.QTHRLIMITESEPHEXTRA, EH.*
  FROM GPE_ALTEESCALA AE
  JOIN GPE_ESCALATRABM EM ON EM.NRORG = AE.NRORG
                         AND EM.NRESCALATRABM = AE.NRESCALATRABM
  JOIN GPE_ESCALATRABH EH ON EH.NRORG = EM.NRORG
                         AND EH.NRESCALATRABM = EM.NRESCALATRABM
                         AND EH.DTMESCOMPETENC = (SELECT MAX(H1.DTMESCOMPETENC) FROM GPE_ESCALATRABH H1
                                                   WHERE H1.NRORG = EH.NRORG
                                                     AND H1.NRESCALATRABM = EH.NRESCALATRABM
                                                     AND H1.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
 WHERE AE.NRORG = :P_NRORG
   AND AE.NRVINCULOM = :P_NRVINCULOM
   AND AE.NRESCALATRABM = :P_NRESCALATRABM
   AND AE.DTINIESCALA = (SELECT MAX(H1.DTINIESCALA) FROM GPE_ALTEESCALA H1
                          WHERE H1.NRORG = AE.NRORG
                            AND H1.NRVINCULOM = AE.NRVINCULOM
                            AND H1.NRESCALATRABM = AE.NRESCALATRABM
                            AND H1.DTINIESCALA <= LAST_DAY(TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')))
SQL;
                $params = array(
                    'P_NRORG' => $nrorg,
                    'P_NRVINCULOM' => $gpe_vinculoh['NRVINCULOM'],
                    'P_NRESCALATRABM' => $gpe_vinculoh['NRESCALATRABM'],
                    'P_DTMESCOMPETENC' => $dtmescompetenc,
                );
                $gpe_escala = $this->entityManager->getConnection()->fetchAssoc($query, $params);


                /* Busca os dados das tabelas gpe_turno, gpe_hordiam e gpe_hordiah */
                $query = <<<SQL
SELECT TU.NRTURNO, TU.DTDATABASE, TU.DSTURNO, HT.NRHORARIOTURNO, HT.NRSEQHORARIO, HT.IDDIAVARIAVEL,
       DECODE(HT.IDDIAVARIAVEL, 'S', 'Dia Variável', TO_CHAR(TU.DTDATABASE + HT.NRSEQHORARIO - 1, 'Day')) AS DIASEMANA,
       HH.*
  FROM GPE_TURNO TU
  JOIN GPE_HORARIOTURNO HT ON HT.NRORG = TU.NRORG
                          AND HT.NRTURNO = TU.NRTURNO
  JOIN GPE_HORDIAH HH ON HH.NRORG = HT.NRORG
                     AND HH.NRHORDIAM = HT.NRHORDIAM
                     AND HH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                FROM GPE_HORDIAH
                                               WHERE GPE_HORDIAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')
                                                 AND GPE_HORDIAH.NRHORDIAM = HH.NRHORDIAM
                                                 AND GPE_HORDIAH.NRORG = HH.NRORG)
 WHERE TU.NRORG = :P_NRORG
   AND TU.NRTURNO = :P_NRTURNO
   AND TU.NRESCALATRABM = :P_NRESCALATRABM
 ORDER BY HT.NRSEQHORARIO
SQL;
                $params = array(
                    'P_NRORG' => $nrorg,
                    'P_NRTURNO' => $gpe_escala['NRTURNO'],
                    'P_NRESCALATRABM' => $gpe_escala['NRESCALATRABM'],
                    'P_DTMESCOMPETENC' => $dtmescompetenc,
                );
                $gpe_turno = $this->entityManager->getConnection()->fetchAll($query, $params);
                $gpe_escala['gpe_turno'] = $gpe_turno;


                // Dados retornados
                $dados[$gpe_pessoah['NRCPFPESSOA']] = array(
                    'gpe_pessoa' => $gpe_pessoa, 
                    'gpe_pessoah' => $gpe_pessoah, 
                    'parcnegocio' => $parcnegocio, 
                    'enderecoparc' => $enderecoparc, 
                    'comunicaparc' => $comunicaparc, 
                    'contcorrparc' => $contcorrparc, 
                    'gpe_vinculom' => $gpe_vinculom,
                    'gpe_vinculoh' => $gpe_vinculoh,
                    'gpe_ocupacao' => $gpe_ocupacao,
                    'gpe_escala' => $gpe_escala,
                );
            }

            return $dados;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getMarcacao($nrorg, $dtmescompetenc, $nrcpfpessoa, $dtiniper, $dtfimper, $cdfilial, $cdcentrocusto){
        try {
            $query = <<<SQL
    SELECT
        EML.CDINTESTRUTEXPFIL CDFILIAL,
        EMG.CDINTESTRUTEXP CDCENTROCUSTO,
        PH.NRCPFPESSOA,
        MARC.DTHRMARCACAOPONTO,
        MARC.DTHRAJUSTADA,
        MARC.IDENQUADRAHORARIO,
        MARC.IDMARCDESPREZADA,
        MARC.IDDIAOCORRENCIA,
        MARC.NRCOLETOR,
        MARC.IDFIXAENTSAID,
        MARC.IDREFERINTERVALO,
        MARC.IDNSRREP,
        MARC.QTHRSDIURNAS,
        MARC.QTHRSNOTURNAS,
        MARC.QTHRSEXTRAS,
        MARC.PERCHRSEXTRAS,
        MARC.IDTPHREXTRA,
        MARC.QTHRSEXTRAS2,
        MARC.PERCHRSEXTRAS2,
        MARC.IDTPHREXTRA2,
        MARC.QTHRSEXTRAS3,
        MARC.PERCHRSEXTRAS3,
        MARC.IDTPHREXTRA3,
        MARC.QTHRSEXTRAS4,
        MARC.PERCHRSEXTRAS4,
        MARC.IDTPHREXTRA4,
        MARC.QTHRSATRASOS,
        MARC.QTHRSCOMPENSAR,
        MARC.IDHRSCOMPENSAR
    FROM
        GPE_MARCACAOPONTO MARC 
    JOIN
        GPE_VINCULOM VM 
            ON VM.NRVINCULOM = MARC.NRVINCULOM 
            AND VM.NRORG = MARC.NRORG   
    JOIN
        GPE_VINCULOH VH 
            ON VH.NRORG = VM.NRORG                       
            AND VH.NRVINCULOM = VM.NRVINCULOM                       
            AND VH.DTMESCOMPETENC = (
                SELECT
                    MAX(H1.DTMESCOMPETENC) 
            FROM
                GPE_VINCULOH H1                                                 
            WHERE
                H1.NRORG = VH.NRORG                                                   
                AND H1.NRVINCULOM = VH.NRVINCULOM                                                   
                AND H1.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')
        )   
    JOIN
        ESTRUTURAM EML 
            ON EML.NRORG = VH.NRORG                      
            AND EML.NRESTRUTURAM = VH.NRESTRUTLEGAL   
    JOIN
        ESTRUTURAM EMG 
            ON EMG.NRORG = VH.NRORG                      
            AND EMG.NRESTRUTURAM = VH.NRESTRUTGEREN 
    JOIN
        GPE_PESSOA PM  
            ON VM.NRPESSOA = PM.NRPESSOA  
            AND VM.NRORG = PM.NRORG  
    JOIN
        GPE_PESSOAH PH              
            ON PM.NRPESSOA = PH.NRPESSOA              
            AND PM.NRORG = PH.NRORG              
            AND PH.DTMESCOMPETENC =(
                SELECT
                    MAX(H1.DTMESCOMPETENC)              
            FROM
                GPE_PESSOAH H1              
            WHERE
                H1.NRPESSOA = PH.NRPESSOA                  
                AND H1.NRORG = PH.NRORG                  
                AND H1.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')        
        )  
    WHERE
        (PH.NRCPFPESSOA = :P_NRCPFPESSOA OR :P_NRCPFPESSOA IS NULL) 
        AND (EML.CDINTESTRUTEXPFIL = :P_CDFILIAL OR :P_CDFILIAL IS NULL) 
        AND (EMG.CDINTESTRUTEXP = :P_CDCENTCUST  OR :P_CDCENTCUST IS NULL) 
        AND MARC.NRORG = :P_NRORG  
        AND(TO_DATE(:P_DTINIPER,'DD/MM/YYYY') <= TO_DATE(TO_CHAR(DTHRMARCACAOPONTO, 'DD/MM/YYYY'),'DD/MM/YYYY')) 
        AND (TO_DATE(:P_DTFIMPER,'DD/MM/YYYY') >= TO_DATE(TO_CHAR(DTHRMARCACAOPONTO, 'DD/MM/YYYY'),'DD/MM/YYYY'))
        ORDER BY NRCPFPESSOA, DTHRMARCACAOPONTO
SQL;
            $params = array(
                'P_NRORG' => $nrorg,
                'P_DTMESCOMPETENC' => $dtmescompetenc,
                'P_NRCPFPESSOA' => $nrcpfpessoa,
                'P_DTINIPER' => $dtiniper,
                'P_DTFIMPER' => $dtfimper,
                'P_CDFILIAL' => $cdfilial,
                'P_CDCENTCUST' => $cdcentrocusto,
            );

            $marcacoes = $this->entityManager->getConnection()->fetchAll($query, $params);
            return $marcacoes;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getDemitidos($dtinicio, $dtfim, $nrvinculom, $dtmescompetenc, $nrorg){
        try {
            $query = <<<SQL
SELECT
    VM.*
FROM
         GPE_VINCULOM VM
    JOIN GPE_VINCULOH VH ON VH.NRVINCULOM = VM.NRVINCULOM
                            AND VH.NRORG = VM.NRORG
                            AND VH.DTMESCOMPETENC = (
        SELECT
            MAX(H1.DTMESCOMPETENC) DTMESCOMPETENC
        FROM
            GPE_VINCULOH H1
        WHERE
                H1.NRVINCULOM = VH.NRVINCULOM
            AND H1.NRORG = VH.NRORG
            AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
    )
WHERE
        VM.NRORG = :P_NRORG
    AND VM.DTRESCISAOVINC IS NOT NULL
    AND ( :P_NRVINCULOM IS NULL
          OR INSTR(','
                   || :P_NRVINCULOM
                   || ',', ','
                           || VM.NRVINCULOM
                           || ',') > 0 )
    AND ( :P_DTINICIO IS NULL
          OR TRUNC(VM.DTRESCISAOVINC) >= :P_DTINICIO )
    AND ( :P_DTFIM IS NULL
          OR TRUNC(VM.DTRESCISAOVINC) <= :P_DTFIM )

SQL;
        $params = array(
            'P_NRVINCULOM' => $nrvinculom,
            'P_DTINICIO' => $dtinicio,
            'P_DTFIM' => $dtfim,
            'P_NRORG' => $nrorg,
            'P_DTMESCOMPETENC' => $dtmescompetenc,
        );

            return $this->entityManager->getConnection()->fetchAll($query, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getColaboradores($dtinicio, $dtfim, $nrvinculom, $dtmescompetenc, $nrorg){
        try {
            $query = <<<SQL
SELECT
    VM.*,
    VH.*,
    PH.*,
    AE.*
FROM
    GPE_VINCULOM   VM
    JOIN GPE_VINCULOH   VH ON VH.NRVINCULOM = VM.NRVINCULOM
                                 AND VH.NRORG = VM.NRORG
                                 AND VH.DTMESCOMPETENC = (
        SELECT
            DTMESCOMPETENC
        FROM
            GPE_VINCULOH
        WHERE
                NRVINCULOM = VH.NRVINCULOM
            AND NRORG = VH.NRORG
            AND DTMESCOMPETENC <= :P_DTMESCOMPETENC
        ORDER BY
            DTMESCOMPETENC DESC
        FETCH FIRST ROW ONLY
    )
    LEFT JOIN GPE_PESSOAH    PH ON PH.NRORG = VM.NRORG
                                AND PH.NRPESSOA = VM.NRPESSOA
                                AND PH.DTMESCOMPETENC = (
        SELECT
            DTMESCOMPETENC
        FROM
            GPE_PESSOAH
        WHERE
                NRPESSOA = PH.NRPESSOA
            AND NRORG = PH.NRORG
            AND DTMESCOMPETENC <= :P_DTMESCOMPETENC
        ORDER BY
            DTMESCOMPETENC DESC
        FETCH FIRST ROW ONLY
    )
    LEFT JOIN GPE_ALTEESCALA AE ON AE.NRORG = VM.NRORG
                                   AND AE.NRVINCULOM = VM.NRVINCULOM
                                   AND AE.DTINIESCALA = (
        SELECT
            DTINIESCALA
        FROM
            GPE_ALTEESCALA
        WHERE
                NRVINCULOM = AE.NRVINCULOM
            AND NRORG = AE.NRORG
        ORDER BY
            DTINIESCALA DESC
        FETCH FIRST ROW ONLY
    )
WHERE
        VM.NRORG = :P_NRORG
    AND ( :P_DTINICIO IS NULL
          OR TRUNC(VM.DTADMISSAOVINC) >= :P_DTINICIO )
    AND ( :P_DTFIM IS NULL
          OR TRUNC(VM.DTADMISSAOVINC) <= :P_DTFIM )
    AND ( :P_NRVINCULOM IS NULL
          OR INSTR(','
                   || :P_NRVINCULOM
                   || ',', ','
                           || VM.NRVINCULOM
                           || ',') > 0 )
    AND ( VM.DTRESCISAOVINC IS NULL
          OR VM.DTRESCISAOVINC > LAST_DAY(:P_DTMESCOMPETENC) )
SQL;
        $params = array(
            'P_NRVINCULOM' => $nrvinculom,
            'P_DTINICIO' => $dtinicio,
            'P_DTFIM' => $dtfim,
            'P_NRORG' => $nrorg,
            'P_DTMESCOMPETENC' => $dtmescompetenc,
        );

            return $this->entityManager->getConnection()->fetchAll($query, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getAfastamentos($dtinicio, $dtfim, $nrvinculom, $dtmescompetenc, $nrorg, $nrorgpadrao){
        try {
            $query = <<<SQL
SELECT
    VM.*,
    VH.*,
    ASF.*,
    SFH.*
FROM
         GPE_VINCULOM VM
    JOIN GPE_VINCULOH     VH ON VH.NRVINCULOM = VM.NRVINCULOM
                            AND VH.NRORG = VM.NRORG
                            AND VH.DTMESCOMPETENC = (
        SELECT
            DTMESCOMPETENC
        FROM
            GPE_VINCULOH
        WHERE
                NRVINCULOM = VH.NRVINCULOM
            AND NRORG = VH.NRORG
            AND DTMESCOMPETENC <= :P_DTMESCOMPETENC
        ORDER BY
            DTMESCOMPETENC DESC
        FETCH FIRST ROW ONLY
    )
    JOIN GPE_ALTESITUFUNC ASF ON ASF.NRVINCULOM = VM.NRVINCULOM
                                 AND ASF.NRORG = VM.NRORG
                                 AND ( :P_DTINICIO IS NULL
                                       OR TRUNC(DTINISITUFUNC) >= :P_DTINICIO )
                                 AND ( :P_DTFIM IS NULL
                                       OR TRUNC(DTFIMSITUFUNC) <= :P_DTFIM )
                                 AND ( ( :P_DTINICIO IS NULL
                                         AND :P_DTFIM IS NULL
                                         AND DTINISITUFUNC <= LAST_DAY(:P_DTMESCOMPETENC) )
                                       OR 1 = 1 )
    JOIN GPE_SITUFUNCH    SFH ON ( SFH.NRORG IS NULL
                                OR SFH.NRORG = :P_NRORG_PADRAO
                                OR SFH.NRORG = VM.NRORG )
                              AND SFH.IDAFASTSITUFUNC = 'S'
                              AND SFH.NRSITUFUNCM = VH.NRSITUFUNCM
                              AND SFH.DTEFETIVA = (
        SELECT
            MAX(DTEFETIVA)
        FROM
            GPE_SITUFUNCH
        WHERE
                DTEFETIVA <= :P_DTMESCOMPETENC
            AND ( SFH.NRORG IS NULL
                  OR SFH.NRORG = :P_NRORG_PADRAO
                  OR SFH.NRORG = VH.NRORG )
            AND NRSITUFUNCM = SFH.NRSITUFUNCM
    )
WHERE
        VM.NRORG = :P_NRORG
    AND ( :P_NRVINCULOM IS NULL
          OR INSTR(','
                   || :P_NRVINCULOM
                   || ',', ','
                           || VM.NRVINCULOM
                           || ',') > 0 )
    AND ( VM.DTRESCISAOVINC IS NULL
          OR VM.DTRESCISAOVINC > LAST_DAY(:P_DTMESCOMPETENC) )
SQL;
        $params = array(
            'P_NRVINCULOM' => $nrvinculom,
            'P_DTINICIO' => $dtinicio,
            'P_DTFIM' => $dtfim,
            'P_NRORG' => $nrorg,
            'P_NRORG_PADRAO' => $nrorgpadrao,
            'P_DTMESCOMPETENC' => $dtmescompetenc,
        );

            return $this->entityManager->getConnection()->fetchAll($query, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getFerias($dtinicio, $dtfim, $nrvinculom, $dtmescompetenc, $nrorg, $nrorgpadrao){
        try {
            $query = <<<SQL
SELECT
    VM.*,
    VH.*,
    FE.*,
    GF.*
FROM
         GPE_VINCULOM VM
    JOIN GPE_VINCULOH   VH ON VH.NRVINCULOM = VM.NRVINCULOM
                            AND VH.NRORG = VM.NRORG
                            AND VH.DTMESCOMPETENC = (
        SELECT
            DTMESCOMPETENC
        FROM
            GPE_VINCULOH
        WHERE
                NRVINCULOM = VH.NRVINCULOM
            AND NRORG = VH.NRORG
            AND DTMESCOMPETENC <= :P_DTMESCOMPETENC
        ORDER BY
            DTMESCOMPETENC DESC
        FETCH FIRST ROW ONLY
    )
    JOIN FPA_FERIAS     FE ON FE.NRORG = VM.NRORG
                          AND FE.NRVINCULOM = VM.NRVINCULOM
    JOIN FPA_GOZOFERIAS GF ON GF.NRORG = VM.NRORG
                              AND GF.NRFERIAS = FE.NRFERIAS
                              AND ( :P_DTINICIO IS NULL
                                    OR TRUNC(GF.DTINIGOZOFERIAS) >= :P_DTINICIO )
                              AND ( :P_DTFIM IS NULL
                                    OR TRUNC(GF.DTFIMGOZOFERIAS) <= :P_DTFIM )
WHERE
        VM.NRORG = :P_NRORG
    AND ( :P_NRVINCULOM IS NULL
          OR INSTR(','
                   || :P_NRVINCULOM
                   || ',', ','
                           || VM.NRVINCULOM
                           || ',') > 0 )
    AND ( VM.DTRESCISAOVINC IS NULL
          OR VM.DTRESCISAOVINC > LAST_DAY(:P_DTMESCOMPETENC) )
SQL;
        $params = array(
            'P_NRVINCULOM' => $nrvinculom,
            'P_DTINICIO' => $dtinicio,
            'P_DTFIM' => $dtfim,
            'P_NRORG' => $nrorg,
            'P_DTMESCOMPETENC' => $dtmescompetenc,
        );

            return $this->entityManager->getConnection()->fetchAll($query, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getMovimentacaoPorTipo($dtinicio, $dtfim, $nrtipo, $dtmescompetenc, $nrorg, $nrorgpadrao){
        try {
            $query = <<<SQL
            SELECT
                VM.*,
                PH.*,
                VH.NRVINCULOH,
                VH.NRSITUFUNCM,
                VH.NRCARGO,
                VH.DTMESCOMPETENC,
                VH.NRESTRUTLEGAL,
                VH.NRESTRUTGEREN,
                MVT.DTINIMOVIMENT AS DTINIMOVIMENT,
                (SELECT DISTINCT FIRST_VALUE(NRESTRUTURAM) OVER (ORDER BY DTINIMOVIMENT DESC) FROM GPE_MOVIMENTACAO M WHERE M.NRORG = MVT.NRORG AND M.NRVINCULOM = MVT.NRVINCULOM AND M.DTINIMOVIMENT <= MVT.DTINIMOVIMENT AND M.NRMOVIMENTACAO != MVT.NRMOVIMENTACAO AND M.NRTIPOTRANSFER = :P_NUMTIPO ) NUMANTERIOR,
                ESTRUTGEREN.CDINTESTRUTURA,
                AE.NRTURNO
            FROM
                GPE_PESSOA PE
                JOIN
                GPE_PESSOAH PH ON
                    PH.NRPESSOA = PE.NRPESSOA AND
                    PH.NRORG =  PE.NRORG
                LEFT JOIN
                GPE_VINCULOM VM ON
                    PE.NRPESSOA = VM.NRPESSOA AND
                    PE.NRORG = VM.NRORG
                LEFT JOIN
                GPE_VINCULOH VH ON
                    VH.NRVINCULOM = VM.NRVINCULOM AND
                    VH.NRORG = VM.NRORG AND
                    VH.DTMESCOMPETENC = (
                        SELECT 
                            MAX(VHH.DTMESCOMPETENC)
                        FROM 
                            GPE_VINCULOH VHH
                        WHERE 
                            VHH.NRVINCULOM = VH.NRVINCULOM AND
                            VHH.NRORG = VH.NRORG AND
                            VHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                    )
                LEFT JOIN GPE_ALTEESCALA AE ON AE.NRORG = VM.NRORG
                                   AND AE.NRVINCULOM = VM.NRVINCULOM
                                   AND AE.DTINIESCALA = (
                    SELECT
                        DTINIESCALA
                    FROM
                        GPE_ALTEESCALA
                    WHERE
                        NRVINCULOM = AE.NRVINCULOM
                        AND NRORG = AE.NRORG
                    ORDER BY
                        DTINIESCALA DESC
                    FETCH FIRST ROW ONLY
                )
                LEFT JOIN
                GPE_OCUPACAOH CARGO ON
                    CARGO.NROCUPACAOM = VH.NRCARGO AND
                    CARGO.NRORG = VH.NRORG AND
                    CARGO.DTMESCOMPETENC = (
                        SELECT
                            MAX(CARGOH.DTMESCOMPETENC)
                        FROM
                            GPE_OCUPACAOH CARGOH
                        WHERE
                            CARGOH.NRORG = CARGO.NRORG AND
                            CARGOH.NROCUPACAOM = CARGO.NROCUPACAOM AND
                            CARGOH.DTMESCOMPETENC <=:P_DTMESCOMPETENC
                    )
                LEFT JOIN
                GPE_MOVIMENTACAO MVT ON
                    MVT.NRORG = VH.NRORG AND
                    MVT.NRVINCULOM = VH.NRVINCULOM
                LEFT JOIN
                ESTRUTURAM ESTRUTGEREN ON
                    ESTRUTGEREN.NRESTRUTURAM = VH.NRESTRUTGEREN AND
                    ESTRUTGEREN.NRORG = VH.NRORG AND
                    ESTRUTGEREN.NRTIPOESTRUTURA = :P_NUMTIPO
            WHERE
                PE.NRORG =:P_NRORG AND
                (
                    MVT.DTINIMOVIMENT BETWEEN :P_DTINICIO AND :P_DTFIM OR
                    MVT.DTFIMMOVIMENT BETWEEN :P_DTINICIO AND :P_DTFIM
                ) AND
                (
                    MVT.NRTIPOESTRUTURA = :P_NUMTIPO
                ) AND
                (
                    (
                        PH.DTMESCOMPETENC = (
                            SELECT
                                MAX(PHH.DTMESCOMPETENC)
                            FROM GPE_PESSOAH PHH
                            WHERE
                                PHH.NRORG = PH.NRORG AND
                                PHH.NRPESSOA = PH.NRPESSOA AND
                                PHH.DTMESCOMPETENC <=:P_DTMESCOMPETENC
                        ) AND
                        VM.NRVINCULOM IS NOT NULL
                    )
                )
            ORDER BY PH.NMPESSOA
SQL;
        $params = array(
            'P_DTINICIO' => $dtinicio,
            'P_DTFIM' => $dtfim,
            'P_NUMTIPO' => $nrtipo,
            'P_DTMESCOMPETENC' => $dtmescompetenc,
            'P_NRORG' => $nrorg,
            'P_NRORGPADRAO' => $nrorgpadrao,
        );

            return $this->entityManager->getConnection()->fetchAll($query, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getVinculosAdmissao(
        string $dtInicioAdmissao, 
        string $dtFinalAdmissao, 
        int $nrCodIntEstrutLegal,
        int $nrOrg
        
    ): array {
    try {
            $sql = <<<SQL
                SELECT
                    VM.*,
                    PH.*,
                    VH.NRVINCULOH,
                    VH.NRSITUFUNCM,
                    VH.NRCARGO,
                    VH.DTMESCOMPETENC,
                    VH.NRESTRUTLEGAL,
                    VH.NRESTRUTGEREN,
                    VH.CDMATRICULAESOCIAL,
                    ESTRUTLEGAL.NMESTRUTURAM AS NMESTRUTLEGAL,
                    ESTRUTLEGAL.CDINTESTRUTURA AS NUMEMP,
                    ESTRUTLEGAL.CDINTESTRUTEXPFIL AS CODFIL,
                    ESTRUTGEREN.NMESTRUTURAM AS NMESTRUTGEREN,
                    ESTRUTGEREN.CDINTESTRUTURA AS CODLOC,
                    CARGO.NMOCUPACAOH AS NMCARGO,
                    CARGO.CDINTEGRACAO AS CODCAR,
                    FUNCAO.NMOCUPACAOH AS NMFUNCAO,
                    CBO.NRCBO,
                    CBO.NMCBO
                FROM
                    GPE_PESSOA PE
                    JOIN
                    GPE_PESSOAH PH ON
                        PH.NRPESSOA = PE.NRPESSOA AND
                        PH.NRORG =  PE.NRORG
                    LEFT JOIN
                    GPE_VINCULOM VM ON
                        PE.NRPESSOA = VM.NRPESSOA AND
                        PE.NRORG = VM.NRORG
                    LEFT JOIN
                    GPE_VINCULOH VH ON
                        VH.NRVINCULOM = VM.NRVINCULOM AND
                        VH.NRORG = VM.NRORG AND
                        VH.DTMESCOMPETENC = (
                            SELECT 
                                MAX(VHH.DTMESCOMPETENC)
                            FROM 
                                GPE_VINCULOH VHH
                            WHERE 
                                VHH.NRVINCULOM = VH.NRVINCULOM AND
                                VHH.NRORG = VH.NRORG AND
                                VHH.DTMESCOMPETENC <= :P_DTFINAL
                        )
                    LEFT JOIN
                    GPE_OCUPACAOH CARGO ON
                        CARGO.NROCUPACAOM = VH.NRCARGO AND
                        CARGO.NRORG = VH.NRORG AND
                        CARGO.DTMESCOMPETENC = (
                            SELECT
                                MAX(CARGOH.DTMESCOMPETENC)
                            FROM
                                GPE_OCUPACAOH CARGOH
                            WHERE
                                CARGOH.NRORG = CARGO.NRORG AND
                                CARGOH.NROCUPACAOM = CARGO.NROCUPACAOM AND
                                CARGOH.DTMESCOMPETENC <=:P_DTFINAL
                        )
                    LEFT JOIN
                    GPE_OCUPACAOH FUNCAO ON
                        FUNCAO.NROCUPACAOM = VH.NRFUNCAO AND
                        FUNCAO.NRORG = VH.NRORG AND
                        FUNCAO.DTMESCOMPETENC = (
                            SELECT
                                MAX(FUNCAOH.DTMESCOMPETENC)
                            FROM
                                GPE_OCUPACAOH FUNCAOH
                            WHERE
                                FUNCAOH.NRORG = FUNCAO.NRORG AND
                                FUNCAOH.NROCUPACAOM = FUNCAO.NROCUPACAOM AND
                                FUNCAOH.DTMESCOMPETENC <=:P_DTFINAL
                        )
                    LEFT JOIN
                    GPE_CBO CBO ON
                        FUNCAO.NRCBO = CBO.NRCBO
                    LEFT JOIN
                    ESTRUTURAM ESTRUTLEGAL ON
                        ESTRUTLEGAL.NRESTRUTURAM = VH.NRESTRUTLEGAL AND
                        ESTRUTLEGAL.NRORG = VH.NRORG
                    LEFT JOIN
                    ESTRUTURAM ESTRUTGEREN ON
                        ESTRUTGEREN.NRESTRUTURAM = VH.NRESTRUTGEREN AND
                        ESTRUTGEREN.NRORG = VH.NRORG
                WHERE
                    PE.NRORG =:P_NRORG AND
                    (
                        VM.DTADMISSAOVINC BETWEEN :P_DTINICIO AND :P_DTFINAL
                    ) AND
                    (
                        ESTRUTLEGAL.CDINTESTRUTURA = :P_NRCODINTESTRUTLEGAL
                    ) AND
                    (
                        (
                            PH.DTMESCOMPETENC = (
                                SELECT
                                    MAX(PHH.DTMESCOMPETENC)
                                FROM GPE_PESSOAH PHH
                                WHERE
                                    PHH.NRORG = PH.NRORG AND
                                    PHH.NRPESSOA = PH.NRPESSOA AND
                                    PHH.DTMESCOMPETENC <=:P_DTFINAL
                            ) AND
                            VM.NRVINCULOM IS NOT NULL
                        )
                    )
                ORDER BY PH.NMPESSOA
SQL;
    
            $params = [
                'P_DTINICIO' => $dtInicioAdmissao,
                'P_DTFINAL' => $dtFinalAdmissao,
                'P_NRCODINTESTRUTLEGAL' => $nrCodIntEstrutLegal,
                'P_NRORG' => $nrOrg
            ];
    

            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getAfastamentoPorPeriodo($dtInicio, $dtFinal, $nrCodIntEstrutLegal, $nrOrg): array {
        try {
            $sql = <<<SQL
                SELECT
                    SITU.IDAFASTSITUFUNC,
                    VM.*,
                    PH.*,
                    VH.NRVINCULOH,
                    VH.NRSITUFUNCM,
                    VH.NRCARGO,
                    VH.DTMESCOMPETENC,
                    VH.NRESTRUTLEGAL,
                    VH.NRESTRUTGEREN,
                    ALTESITU.NRSITUFUNCM,
                    ALTESITU.DTINISITUFUNC,
                    ALTESITU.DTFIMSITUFUNC,
                    ESTRUTLEGAL.NMESTRUTURAM AS NMESTRUTLEGAL,
                    ESTRUTLEGAL.CDINTESTRUTURA AS NUMEMP,
                    ESTRUTGEREN.NMESTRUTURAM AS NMESTRUTGEREN
                FROM
                    GPE_PESSOA PE
                    JOIN
                    GPE_PESSOAH PH ON
                        PH.NRPESSOA = PE.NRPESSOA AND
                        PH.NRORG =  PE.NRORG
                    LEFT JOIN
                    GPE_VINCULOM VM ON
                        PE.NRPESSOA = VM.NRPESSOA AND
                        PE.NRORG = VM.NRORG
                    LEFT JOIN
                    GPE_VINCULOH VH ON
                        VH.NRVINCULOM = VM.NRVINCULOM AND
                        VH.NRORG = VM.NRORG AND
                        VH.DTMESCOMPETENC = (
                            SELECT 
                                MAX(VHH.DTMESCOMPETENC)
                            FROM 
                                GPE_VINCULOH VHH
                            WHERE 
                                VHH.NRVINCULOM = VH.NRVINCULOM AND
                                VHH.NRORG = VH.NRORG AND
                                VHH.DTMESCOMPETENC <= :P_DTFINAL
                        )
                    LEFT JOIN
                    GPE_ALTESITUFUNC ALTESITU ON
                        ALTESITU.NRORG = VH.NRORG AND
                        ALTESITU.NRVINCULOM = VH.NRVINCULOM
                    LEFT JOIN
                    GPE_SITUFUNCH SITU ON
                        SITU.NRSITUFUNCM = ALTESITU.NRSITUFUNCM AND
                        SITU.DTEFETIVA = (
                            SELECT 
                              MAX(DTEFETIVA) 
                            FROM 
                              GPE_SITUFUNCH 
                            WHERE 
                              GPE_SITUFUNCH.NRSITUFUNCM = ALTESITU.NRSITUFUNCM 
                              AND GPE_SITUFUNCH.DTEFETIVA <= :P_DTFINAL
                        ) 
                    LEFT JOIN
                    ESTRUTURAM ESTRUTLEGAL ON
                        ESTRUTLEGAL.NRESTRUTURAM = VH.NRESTRUTLEGAL AND
                        ESTRUTLEGAL.NRORG = VH.NRORG
                    LEFT JOIN
                    ESTRUTURAM ESTRUTGEREN ON
                        ESTRUTGEREN.NRESTRUTURAM = VH.NRESTRUTGEREN AND
                        ESTRUTGEREN.NRORG = VH.NRORG
                WHERE
                    PE.NRORG =:P_NRORG AND
                    (
                        ALTESITU.DTINISITUFUNC BETWEEN :P_DTINICIO AND :P_DTFINAL OR 
                        ALTESITU.DTFIMSITUFUNC BETWEEN :P_DTINICIO AND :P_DTFINAL
                    ) AND
                    (
                        ESTRUTLEGAL.CDINTESTRUTURA = :P_NRCODINTESTRUTLEGAL
                    ) AND 
                    (
                        SITU.IDAFASTSITUFUNC = 'S'
                    ) AND
                    (
                        (
                            PH.DTMESCOMPETENC = (
                                SELECT
                                    MAX(PHH.DTMESCOMPETENC)
                                FROM GPE_PESSOAH PHH
                                WHERE
                                    PHH.NRORG = PH.NRORG AND
                                    PHH.NRPESSOA = PH.NRPESSOA AND
                                    PHH.DTMESCOMPETENC <=:P_DTFINAL
                            ) AND
                            VM.NRVINCULOM IS NOT NULL
                        )
                    )
                ORDER BY PH.NMPESSOA
SQL;
    
            $params = [
                'P_DTINICIO' => $dtInicio,
                'P_DTFINAL' => $dtFinal,
                'P_NRCODINTESTRUTLEGAL' => $nrCodIntEstrutLegal,
                'P_NRORG' => $nrOrg
            ];
    
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getMovimentacao($dtInicio, $dtFinal, $nrCodIntEstrutLegal, $nrOrg): array {
        try {
            $sql = <<<SQL
                SELECT
                    PH.NMPESSOA,
                    VM.CDMATRICULA AS NUMCAD,
                    PH.NRCPFPESSOA AS NUMCPF,
                    VH.NRESTRUTLEGAL AS ENUMEMP,
                    VH.CDMATRICULAESOCIAL AS MATESO,
                    MVT.DTINIMOVIMENT AS DATALT,
                    ESTRUTLEGAL.NMESTRUTURAM AS NMESTRUTLEGAL,
                    ESTRUTLEGAL.CDINTESTRUTURA AS NUMEMP,
                    ESTRUTLEGAL.CDINTESTRUTEXPFIL AS CODFIL,
                    ESTRUTGEREN.NMESTRUTURAM AS NMESTRUTGEREN,
                    ESTRUTGEREN.CDINTESTRUTURA AS CODLOC,
                    CARGO.CDINTEGRACAO AS CODCAR
                FROM
                    GPE_PESSOA PE
                    JOIN
                    GPE_PESSOAH PH ON
                        PH.NRPESSOA = PE.NRPESSOA AND
                        PH.NRORG =  PE.NRORG
                    JOIN
                    GPE_VINCULOM VM ON
                        PE.NRPESSOA = VM.NRPESSOA AND
                        PE.NRORG = VM.NRORG
                    JOIN
                    GPE_VINCULOH VH ON
                        VH.NRVINCULOM = VM.NRVINCULOM AND
                        VH.NRORG = VM.NRORG AND
                        VH.DTMESCOMPETENC = ( SELECT * 
                            FROM (
                                SELECT 
                                    VHH.DTMESCOMPETENC
                                FROM 
                                    GPE_VINCULOH VHH
                                WHERE
                                    VHH.DTMESCOMPETENC <= :P_DTFINAL AND
                                    VHH.NRORG = VH.NRORG AND
                                    VHH.NRVINCULOM = VH.NRVINCULOM
                                ORDER BY VHH.DTMESCOMPETENC DESC
                            )
                            WHERE ROWNUM=1
                        )
                    LEFT JOIN
                    GPE_OCUPACAOH CARGO ON
                        CARGO.NROCUPACAOM = VH.NRCARGO AND
                        CARGO.NRORG = VH.NRORG AND
                        CARGO.DTMESCOMPETENC = (
                            SELECT
                                MAX(CARGOH.DTMESCOMPETENC)
                            FROM
                                GPE_OCUPACAOH CARGOH
                            WHERE
                                CARGOH.NRORG = CARGO.NRORG AND
                                CARGOH.NROCUPACAOM = CARGO.NROCUPACAOM AND
                                CARGOH.DTMESCOMPETENC <=:P_DTFINAL
                        )
                    JOIN
                    GPE_MOVIMENTACAO MVT ON
                        MVT.NRORG = VH.NRORG AND
                        MVT.NRVINCULOM = VH.NRVINCULOM
                    LEFT JOIN
                    ESTRUTURAM ESTRUTLEGAL ON
                        ESTRUTLEGAL.NRESTRUTURAM = VH.NRESTRUTLEGAL AND
                        ESTRUTLEGAL.NRORG = VH.NRORG
                    LEFT JOIN
                    ESTRUTURAM ESTRUTGEREN ON
                        ESTRUTGEREN.NRESTRUTURAM = VH.NRESTRUTGEREN AND
                        ESTRUTGEREN.NRORG = VH.NRORG
                WHERE
                    PE.NRORG =:P_NRORG AND
                    (
                        MVT.DTINIMOVIMENT BETWEEN :P_DTINICIO AND :P_DTFINAL OR
                        MVT.DTFIMMOVIMENT BETWEEN :P_DTINICIO AND :P_DTFINAL
                    ) AND
                    (
                        ESTRUTLEGAL.CDINTESTRUTURA = :P_NRCODINTESTRUTLEGAL
                    ) AND
                    (
                        (
                            PH.DTMESCOMPETENC = (
                                SELECT
                                    MAX(PHH.DTMESCOMPETENC)
                                FROM GPE_PESSOAH PHH
                                WHERE
                                    PHH.NRORG = PH.NRORG AND
                                    PHH.NRPESSOA = PH.NRPESSOA AND
                                    PHH.DTMESCOMPETENC <=:P_DTFINAL
                            ) AND
                            VM.NRVINCULOM IS NOT NULL
                        )
                    )
SQL;
    
            $params = [
                'P_DTINICIO' => $dtInicio,
                'P_DTFINAL' => $dtFinal,
                'P_NRCODINTESTRUTLEGAL' => $nrCodIntEstrutLegal,
                'P_NRORG' => $nrOrg
            ];
    
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getAlteracaoCargo($dtInicio, $dtFinal, $nrCodIntEstrutLegal, $nrOrg): array {
        try {
            $sql = <<<SQL
                SELECT
                    PH.NMPESSOA,
                    VM.CDMATRICULA,
                    PH.NRCPFPESSOA,
                    VH.NRESTRUTLEGAL,
                    CARGO.DTINIOCUPACAO AS DATALT,
                    ESTRUTLEGAL.NMESTRUTURAM AS NMESTRUTLEGAL,
                    ESTRUTLEGAL.CDINTESTRUTURA AS NUMEMP,
                    ESTRUTGEREN.NMESTRUTURAM AS NMESTRUTGEREN,
                    OH.CDINTEGRACAO AS CODCAR
                FROM
                    GPE_PESSOA PE
                    JOIN
                    GPE_PESSOAH PH ON
                        PH.NRPESSOA = PE.NRPESSOA AND
                        PH.NRORG =  PE.NRORG
                    JOIN
                    GPE_VINCULOM VM ON
                        PE.NRPESSOA = VM.NRPESSOA AND
                        PE.NRORG = VM.NRORG
                    JOIN
                    GPE_VINCULOH VH ON
                        VH.NRVINCULOM = VM.NRVINCULOM AND
                        VH.NRORG = VM.NRORG AND
                        VH.DTMESCOMPETENC = ( SELECT * 
                            FROM (
                                SELECT 
                                    VHH.DTMESCOMPETENC
                                FROM 
                                    GPE_VINCULOH VHH
                                WHERE
                                    VHH.DTMESCOMPETENC <= :P_DTFINAL AND
                                    VHH.NRORG = VH.NRORG AND
                                    VHH.NRVINCULOM = VH.NRVINCULOM
                                ORDER BY VHH.DTMESCOMPETENC DESC
                            )
                            WHERE ROWNUM=1
                        )
                    LEFT JOIN
                    GPE_OCUPACAOH OH ON
                        OH.NROCUPACAOM = VH.NRCARGO AND
                        OH.NRORG = VH.NRORG AND
                        OH.DTMESCOMPETENC = (
                            SELECT
                                MAX(OHH.DTMESCOMPETENC)
                            FROM
                                GPE_OCUPACAOH OHH
                            WHERE
                                OHH.NRORG = OH.NRORG AND
                                OHH.NROCUPACAOM = OH.NROCUPACAOM AND
                                OHH.DTMESCOMPETENC <=:P_DTFINAL
                        )
                    LEFT JOIN 
                    GPE_ALTEOCUPACAO CARGO ON
                        CARGO.NRORG = VH.NRORG AND
                        CARGO.NRVINCULOM = VH.NRVINCULOM
                    LEFT JOIN
                    ESTRUTURAM ESTRUTLEGAL ON
                        ESTRUTLEGAL.NRESTRUTURAM = VH.NRESTRUTLEGAL AND
                        ESTRUTLEGAL.NRORG = VH.NRORG
                    LEFT JOIN
                    ESTRUTURAM ESTRUTGEREN ON
                        ESTRUTGEREN.NRESTRUTURAM = VH.NRESTRUTGEREN AND
                        ESTRUTGEREN.NRORG = VH.NRORG
                WHERE
                    PE.NRORG =:P_NRORG AND
                    (
                        CARGO.DTINIOCUPACAO BETWEEN :P_DTINICIO AND :P_DTFINAL OR
                        CARGO.DTFIMOCUPACAO BETWEEN :P_DTINICIO AND :P_DTFINAL
                    ) AND
                    (
                        ESTRUTLEGAL.CDINTESTRUTURA = :P_NRCODINTESTRUTLEGAL
                    ) AND
                    (
                        (
                            PH.DTMESCOMPETENC = (
                                SELECT
                                    MAX(PHH.DTMESCOMPETENC)
                                FROM GPE_PESSOAH PHH
                                WHERE
                                    PHH.NRORG = PH.NRORG AND
                                    PHH.NRPESSOA = PH.NRPESSOA AND
                                    PHH.DTMESCOMPETENC <=:P_DTFINAL
                            ) AND
                            VM.NRVINCULOM IS NOT NULL
                        )
                    )
SQL;
    
            $params = [
                'P_DTINICIO' => $dtInicio,
                'P_DTFINAL' => $dtFinal,
                'P_NRCODINTESTRUTLEGAL' => $nrCodIntEstrutLegal,
                'P_NRORG' => $nrOrg
            ];
    
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getMovporTipo($dtInicio, $dtFinal, $Tipo, $nrCodIntEstrutLegal, $nrOrg, $nrEstrutLegalParamOrg, $nrEstrutGerenParamOrg): array {
        try {
            $sql = <<<SQL
                SELECT
                    PH.NMPESSOA,
                    VM.CDMATRICULA,
                    PH.NRCPFPESSOA,
                    VH.NRESTRUTLEGAL,
                    MVT.DTINIMOVIMENT AS DATALT,
                    VH.CDMATRICULAESOCIAL,
                    (SELECT DISTINCT FIRST_VALUE(NRESTRUTURAM) OVER (ORDER BY DTINIMOVIMENT DESC) FROM GPE_MOVIMENTACAO M WHERE M.NRORG = MVT.NRORG AND M.NRVINCULOM = MVT.NRVINCULOM AND M.DTINIMOVIMENT <= MVT.DTINIMOVIMENT AND M.NRMOVIMENTACAO != MVT.NRMOVIMENTACAO AND M.NRTIPOTRANSFER = :P_TIPO ) NUMANTERIOR,
                    ESTRUTLEGAL.NMESTRUTURAM AS NMESTRUTLEGAL,
                    ESTRUTLEGAL.CDINTESTRUTURA AS NUMEMP,
                    ESTRUTGEREN.NMESTRUTURAM AS NMESTRUTGEREN
                FROM
                    GPE_PESSOA PE
                    JOIN
                    GPE_PESSOAH PH ON
                        PH.NRPESSOA = PE.NRPESSOA AND
                        PH.NRORG =  PE.NRORG
                    JOIN
                    GPE_VINCULOM VM ON
                        PE.NRPESSOA = VM.NRPESSOA AND
                        PE.NRORG = VM.NRORG
                    JOIN
                    GPE_VINCULOH VH ON
                        VH.NRVINCULOM = VM.NRVINCULOM AND
                        VH.NRORG = VM.NRORG AND
                        VH.DTMESCOMPETENC = ( SELECT * 
                            FROM (
                                SELECT 
                                    VHH.DTMESCOMPETENC
                                FROM 
                                    GPE_VINCULOH VHH
                                WHERE
                                    VHH.DTMESCOMPETENC <= :P_DTFINAL AND
                                    VHH.NRORG = VH.NRORG AND
                                    VHH.NRVINCULOM = VH.NRVINCULOM
                                ORDER BY VHH.DTMESCOMPETENC DESC
                            )
                            WHERE ROWNUM=1
                        )
                    LEFT JOIN
                    GPE_OCUPACAOH CARGO ON
                        CARGO.NROCUPACAOM = VH.NRCARGO AND
                        CARGO.NRORG = VH.NRORG AND
                        CARGO.DTMESCOMPETENC = (
                            SELECT
                                MAX(CARGOH.DTMESCOMPETENC)
                            FROM
                                GPE_OCUPACAOH CARGOH
                            WHERE
                                CARGOH.NRORG = CARGO.NRORG AND
                                CARGOH.NROCUPACAOM = CARGO.NROCUPACAOM AND
                                CARGOH.DTMESCOMPETENC <=:P_DTFINAL
                        )
                    JOIN
                    GPE_MOVIMENTACAO MVT ON
                        MVT.NRORG = VH.NRORG AND
                        MVT.NRVINCULOM = VH.NRVINCULOM
                    LEFT JOIN
                    ESTRUTURAM ESTRUTLEGAL ON
                        ESTRUTLEGAL.NRESTRUTURAM = VH.NRESTRUTLEGAL AND
                        ESTRUTLEGAL.NRORG = VH.NRORG
                    LEFT JOIN
                    ESTRUTURAM ESTRUTGEREN ON
                        ESTRUTGEREN.NRESTRUTURAM = VH.NRESTRUTGEREN AND
                        ESTRUTGEREN.NRORG = VH.NRORG
                WHERE
                    PE.NRORG =:P_NRORG AND
                    (
                        MVT.DTINIMOVIMENT BETWEEN :P_DTINICIO AND :P_DTFINAL OR
                        MVT.DTFIMMOVIMENT BETWEEN :P_DTINICIO AND :P_DTFINAL
                    ) AND
                    (
                        ESTRUTLEGAL.CDINTESTRUTURA = :P_NRCODINTESTRUTLEGAL
                    ) AND
                    (
                        MVT.NRTIPOTRANSFER = :P_TIPO AND MVT.NRTIPOESTRUTURA = DECODE(:P_TIPO, 1, :P_TIPOESTRUTLEGAL, 2, :P_TIPOESTRUTGEREN)
                    ) AND
                    (
                        (
                            PH.DTMESCOMPETENC = (
                                SELECT
                                    MAX(PHH.DTMESCOMPETENC)
                                FROM GPE_PESSOAH PHH
                                WHERE
                                    PHH.NRORG = PH.NRORG AND
                                    PHH.NRPESSOA = PH.NRPESSOA AND
                                    PHH.DTMESCOMPETENC <=:P_DTFINAL
                            ) AND
                            VM.NRVINCULOM IS NOT NULL
                        )
                    )
SQL;
    
            $params = [
                'P_DTINICIO' => $dtInicio,
                'P_DTFINAL' => $dtFinal,
                'P_TIPO' => $Tipo,
                'P_NRCODINTESTRUTLEGAL' => $nrCodIntEstrutLegal,
                'P_NRORG' => $nrOrg,
                'P_TIPOESTRUTLEGAL' => $nrEstrutLegalParamOrg,
                'P_TIPOESTRUTGEREN' => $nrEstrutGerenParamOrg
            ];
    
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
}