IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'TRILHAUDIT_RECURSOANA' AND
                TYPE   = 'TR'               AND
                U.UID  = O.UID              AND
                U.NAME = USER)

DROP TRIGGER TRILHAUDIT_RECURSOANA
GO

CREATE TRIGGER TRILHAUDIT_RECURSOANA
ON RECURSOANA
FOR UPDATE,INSERT, DELETE
AS
BEGIN
   DECLARE @V_NRSEQTRILHA  NUMERIC(10);
   DECLARE @V_NMPRODUTO    VARCHAR(50);
   DECLARE @V_ITEMALTERADO VARCHAR(300);
   DECLARE @V_NEWTIPOINSU  VARCHAR(50);
   DECLARE @V_NMRECURSO    VARCHAR(50);
   DECLARE @V_OLDTIPOINSU  VARCHAR(50);
   DECLARE @V_CDOPERADOR   VARCHAR(12);
   DECLARE @V_CLIENT_INFO  VARCHAR(64);
   DECLARE @V_TIPO         VARCHAR(1);
   DECLARE @V_DSREMOTEADDR VARCHAR(15);
   DECLARE @V_DSREMOTEHOST VARCHAR(15);
   DECLARE @V_DSSERVERRDM  VARCHAR(20);
   DECLARE @V_DSSERVMETHOD VARCHAR(30);
   DECLARE @V_DSREMOTEOPER VARCHAR(12);

   DECLARE @V_NRSEQRECURSOANA_NEW NUMERIC;
   DECLARE @V_CDPRODUTO_NEW       VARCHAR(10);
   DECLARE @V_IDPROCPROD_NEW      VARCHAR(1);
   DECLARE @V_CDINSPECAO_NEW      VARCHAR(10);
   DECLARE @V_IDTPRECURSO_NEW     VARCHAR(1);
   DECLARE @V_CDEQUIPPRO_NEW      VARCHAR(10);
   DECLARE @V_CDHABILIDADE_NEW    VARCHAR(3);
   DECLARE @V_QTRECURANA_NEW      DOUBLE PRECISION;
   DECLARE @V_QTHORARECURANA_NEW  DOUBLE PRECISION;

   DECLARE @V_NRSEQRECURSOANA_OLD NUMERIC;
   DECLARE @V_CDPRODUTO_OLD       VARCHAR(10);
   DECLARE @V_IDPROCPROD_OLD      VARCHAR(1);
   DECLARE @V_CDINSPECAO_OLD      VARCHAR(10);
   DECLARE @V_IDTPRECURSO_OLD     VARCHAR(1);
   DECLARE @V_CDEQUIPPRO_OLD      VARCHAR(10);
   DECLARE @V_CDHABILIDADE_OLD    VARCHAR(3);
   DECLARE @V_QTRECURANA_OLD      DOUBLE PRECISION;
   DECLARE @V_QTHORARECURANA_OLD  DOUBLE PRECISION;

   SET @V_ITEMALTERADO = '';

   DECLARE C_CURSOR_R CURSOR FOR
      SELECT
         'E' IDCOMANDO,
         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL,
         NRSEQRECURSOANA,
         CDPRODUTO,
         IDPROCPROD,
         CDINSPECAO,
         IDTPRECURSO,
         CDEQUIPPRO,
         CDHABILIDADE,
         QTRECURANA,
         QTHORARECURANA
      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'A' IDCOMANDO,
         INSERTED.NRSEQRECURSOANA,
         INSERTED.CDPRODUTO,
         INSERTED.IDPROCPROD,
         INSERTED.CDINSPECAO,
         INSERTED.IDTPRECURSO,
         INSERTED.CDEQUIPPRO,
         INSERTED.CDHABILIDADE,
         INSERTED.QTRECURANA,
         INSERTED.QTHORARECURANA,

         DELETED.NRSEQRECURSOANA,
         DELETED.CDPRODUTO,
         DELETED.IDPROCPROD,
         DELETED.CDINSPECAO,
         DELETED.IDTPRECURSO,
         DELETED.CDEQUIPPRO,
         DELETED.CDHABILIDADE,
         DELETED.QTRECURANA,
         DELETED.QTHORARECURANA

      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.NRSEQRECURSOANA = DELETED.NRSEQRECURSOANA

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         INSERTED.NRSEQRECURSOANA,
         INSERTED.CDPRODUTO,
         INSERTED.IDPROCPROD,
         INSERTED.CDINSPECAO,
         INSERTED.IDTPRECURSO,
         INSERTED.CDEQUIPPRO,
         INSERTED.CDHABILIDADE,
         INSERTED.QTRECURANA,
         INSERTED.QTHORARECURANA,

         NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)
      OPEN C_CURSOR_R;
      FETCH NEXT FROM C_CURSOR_R INTO @V_TIPO, @V_NRSEQRECURSOANA_NEW, @V_CDPRODUTO_NEW, @V_IDPROCPROD_NEW,
                                      @V_CDINSPECAO_NEW, @V_IDTPRECURSO_NEW, @V_CDEQUIPPRO_NEW, @V_CDHABILIDADE_NEW,
                                      @V_QTRECURANA_NEW, @V_QTHORARECURANA_NEW,

                                      @V_NRSEQRECURSOANA_OLD, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, @V_CDINSPECAO_OLD,
                                      @V_IDTPRECURSO_OLD, @V_CDEQUIPPRO_OLD, @V_CDHABILIDADE_OLD,
                                      @V_QTRECURANA_OLD, @V_QTHORARECURANA_OLD;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF (@V_TIPO = 'E') BEGIN
            SET @V_ITEMALTERADO = 'Excluso de Recurso';

            EXEC WEBTUNNING @V_DSREMOTEADDR,
                            @V_DSREMOTEHOST,
                            @V_DSSERVERRDM,
                            @V_DSSERVMETHOD,
                            @V_DSREMOTEOPER;

            SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
             FROM TRILHAUDIT;

            IF (@V_IDTPRECURSO_OLD = 'E') BEGIN
               SELECT @V_NMRECURSO = NMEQUIPPRO
                 FROM EQUIPAPROD
                WHERE CDEQUIPPRO = @V_CDEQUIPPRO_OLD;
            END
            ELSE BEGIN
               SELECT @V_NMRECURSO = NMHABILIDADE
                 FROM HABILIDADE
                WHERE CDHABILIDADE = @V_CDHABILIDADE_OLD;
            END;

            INSERT INTO TRILHAUDIT
             (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
            VALUES
             (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'E', GETDATE(), NULL, 'Excluso do Recurso ' + @V_NMRECURSO, @V_DSREMOTEOPER, 'Excluso de Reagente ');

         END
         ELSE IF (@V_TIPO = 'I') BEGIN
            SET @V_ITEMALTERADO = 'Insero de Recurso';

            EXEC WEBTUNNING @V_DSREMOTEADDR,
                            @V_DSREMOTEHOST,
                            @V_DSSERVERRDM,
                            @V_DSSERVMETHOD,
                            @V_DSREMOTEOPER;

            SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
             FROM TRILHAUDIT;

            IF (@V_IDTPRECURSO_NEW = 'E') BEGIN
               SELECT @V_NMRECURSO = NMEQUIPPRO
                 FROM EQUIPAPROD
                WHERE CDEQUIPPRO = @V_CDEQUIPPRO_NEW;
            END
            ELSE BEGIN
               SELECT NMHABILIDADE
                 FROM HABILIDADE
                WHERE CDHABILIDADE = @V_CDHABILIDADE_NEW;
            END;

            INSERT INTO TRILHAUDIT
             (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
            VALUES
             (@V_NRSEQTRILHA, @V_CDPRODUTO_NEW, @V_IDPROCPROD_NEW, 'I', GETDATE(), NULL, 'Insero do Recurso ' + @V_NMRECURSO, @V_DSREMOTEOPER, @V_ITEMALTERADO);
         END
         ELSE BEGIN
            EXEC WEBTUNNING @V_DSREMOTEADDR,
                            @V_DSREMOTEHOST,
                            @V_DSSERVERRDM,
                            @V_DSSERVMETHOD,
                            @V_DSREMOTEOPER;

            IF (@V_QTRECURANA_NEW <> @V_QTRECURANA_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Quantidade do Recurso';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_QTRECURANA_OLD, @V_QTRECURANA_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;

            IF (@V_QTHORARECURANA_NEW <> @V_QTHORARECURANA_OLD) BEGIN
               SET @V_ITEMALTERADO = 'Quantidade Horas';

               SELECT @V_NRSEQTRILHA = ISNULL(MAX(NRSEQTRILHA) ,0) + 1
                 FROM TRILHAUDIT;

               INSERT INTO TRILHAUDIT
                (NRSEQTRILHA, CDPRODUTO, IDPROCPROD, IDTPALTERA, DTALTERACAO, DSANTIGADESC, DSNOVADESC, CDOPERADOR, ITEMALTERA)
               VALUES
                (@V_NRSEQTRILHA, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, 'A', GETDATE(), @V_QTHORARECURANA_OLD, @V_QTHORARECURANA_NEW, @V_DSREMOTEOPER, @V_ITEMALTERADO);
            END;
         END;

      FETCH NEXT FROM C_CURSOR_R INTO @V_TIPO, @V_NRSEQRECURSOANA_NEW, @V_CDPRODUTO_NEW, @V_IDPROCPROD_NEW,
                                      @V_CDINSPECAO_NEW, @V_IDTPRECURSO_NEW, @V_CDEQUIPPRO_NEW, @V_CDHABILIDADE_NEW,
                                      @V_QTRECURANA_NEW, @V_QTHORARECURANA_NEW,

                                      @V_NRSEQRECURSOANA_OLD, @V_CDPRODUTO_OLD, @V_IDPROCPROD_OLD, @V_CDINSPECAO_OLD,
                                      @V_IDTPRECURSO_OLD, @V_CDEQUIPPRO_OLD, @V_CDHABILIDADE_OLD,
                                      @V_QTRECURANA_OLD, @V_QTHORARECURANA_OLD;
   END;
   CLOSE C_CURSOR_R;
   DEALLOCATE C_CURSOR_R;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'TRILHAUDIT_RECURSOANA','6.05.xxx';
GO